Index: stable/HeuristicLab.Optimizer/3.3/CreateExperimentDialog.Designer.cs
===================================================================
--- stable/HeuristicLab.Optimizer/3.3/CreateExperimentDialog.Designer.cs	(revision 13885)
+++ stable/HeuristicLab.Optimizer/3.3/CreateExperimentDialog.Designer.cs	(revision 13911)
@@ -147,6 +147,6 @@
       // repetitionsNumericUpDown
       // 
-      this.repetitionsNumericUpDown.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.repetitionsNumericUpDown.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.repetitionsNumericUpDown.Location = new System.Drawing.Point(113, 28);
       this.repetitionsNumericUpDown.Maximum = new decimal(new int[] {
@@ -234,7 +234,7 @@
       // tabControl
       // 
-      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.tabControl.Controls.Add(this.parametersTabPage);
       this.tabControl.Controls.Add(this.instancesTabPage);
@@ -287,4 +287,5 @@
       this.parametersListView.MultiSelect = false;
       this.parametersListView.Name = "parametersListView";
+      this.parametersListView.ShowItemToolTips = true;
       this.parametersListView.Size = new System.Drawing.Size(155, 285);
       this.parametersListView.TabIndex = 0;
@@ -310,7 +311,7 @@
       // stringConvertibleArrayView
       // 
-      this.stringConvertibleArrayView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.stringConvertibleArrayView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.stringConvertibleArrayView.Caption = "StringConvertibleArray View";
       this.stringConvertibleArrayView.Content = null;
@@ -332,7 +333,7 @@
       // choicesListView
       // 
-      this.choicesListView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.choicesListView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.choicesListView.CheckBoxes = true;
       this.choicesListView.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
@@ -378,7 +379,7 @@
       // instancesTreeView
       // 
-      this.instancesTreeView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.instancesTreeView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.instancesTreeView.CheckBoxes = true;
       this.instancesTreeView.Location = new System.Drawing.Point(6, 35);
@@ -422,6 +423,6 @@
       // experimentCreationProgressBar
       // 
-      this.experimentCreationProgressBar.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.experimentCreationProgressBar.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.experimentCreationProgressBar.Location = new System.Drawing.Point(187, 377);
       this.experimentCreationProgressBar.Name = "experimentCreationProgressBar";
Index: stable/HeuristicLab.Optimizer/3.3/CreateExperimentDialog.cs
===================================================================
--- stable/HeuristicLab.Optimizer/3.3/CreateExperimentDialog.cs	(revision 13885)
+++ stable/HeuristicLab.Optimizer/3.3/CreateExperimentDialog.cs	(revision 13911)
@@ -56,13 +56,13 @@
     private bool createBatchRun;
     private int repetitions;
-    private Dictionary<IProblemInstanceProvider, HashSet<IDataDescriptor>> instances;
-    private Dictionary<IValueParameter, IntArray> intParameters;
-    private Dictionary<IValueParameter, DoubleArray> doubleParameters;
-    private HashSet<IValueParameter> boolParameters;
-    private Dictionary<IValueParameter, HashSet<IItem>> multipleChoiceParameters;
-    private IItem optionalNullChoice = new BoolValue(); // any item will do
+    private readonly Dictionary<IProblemInstanceProvider, HashSet<IDataDescriptor>> instances;
+    private readonly Dictionary<IValueParameter, IntArray> intParameters;
+    private readonly Dictionary<IValueParameter, DoubleArray> doubleParameters;
+    private readonly HashSet<IValueParameter> boolParameters;
+    private readonly Dictionary<IValueParameter, HashSet<IItem>> multipleChoiceParameters;
+    private readonly IItem optionalNullChoice = new BoolValue(); // any item will do
 
     private StringBuilder failedInstances;
-    private EventWaitHandle backgroundWorkerWaitHandle = new ManualResetEvent(false);
+    private readonly EventWaitHandle backgroundWorkerWaitHandle = new ManualResetEvent(false);
     private bool suppressTreeViewEventHandling, suppressCheckAllNoneEventHandling;
 
@@ -489,5 +489,5 @@
             || typeof(OptionalConstrainedValueParameter<>).IsAssignableFrom(param.GetType().GetGenericTypeDefinition())
             || typeof(ConstrainedValueParameter<>).IsAssignableFrom(param.GetType().GetGenericTypeDefinition()))
-            parametersListView.Items.Add(new ListViewItem(param.Name) { Tag = param });
+            parametersListView.Items.Add(new ListViewItem(param.Name) { Tag = param, ToolTipText = param.Description });
         }
       }